# Dummy client for testing StartsServer separate from HTTP.  See implementation
# ntoes Web page for more information.

#!/usr/bin/perl5


$soif = '@SQuery{Version{10}:	STARTS 1.0FilterExpression{50}:	((author "Garcia Molina") and (title "databases"))RankingExpression{45}:	list ((title "algorithm") (title "abstract"))StopWords{1}:	TDefaultAttributeSet{7}:	basic-1DefaultLanguage{5}:	en-USAnswerFields{12}:	title authorMinDocumentScore{3}:	0.5MaxNumberDocuments{2}:	10}';

#$soif = '@SQuery{Version{10}:	STARTS 1.0FilterExpression{24}:	(author "Garcia Molina")StopWords{1}:	TDefaultAttributeSet{7}:	basic-1DefaultLanguage{5}:	en-USAnswerFields{12}:	title authorMinDocumentScore{3}:	0.5MaxNumberDocuments{2}:	10}';

($them,$port) = @ARGV;
$port = 2345 unless $port;
$them = 'localhost' unless $them;

$AF_INET = 2;
$SOCK_STREAM = 2;

$SIG{'INT'} = 'dokill';
sub dokill {
    kill 9,$child if $child;
}

$sockaddr = 'S n a4 x8';

chop($hostname = `hostname`);

($name,$aliases,$proto) = getprotobyname('tcp');
($name,$aliases,$port) = getservbyname($port,'tcp')
    unless $port =~ /^\d+$/;;
($name,$aliases,$type,$len,$thisaddr) =
	gethostbyname($hostname);
($name,$aliases,$type,$len,$thataddr) = gethostbyname($them);

$this = pack($sockaddr, $AF_INET, 0, $thisaddr);
$that = pack($sockaddr, $AF_INET, $port, $thataddr);

# Make the socket filehandle.

if (socket(S, $AF_INET, $SOCK_STREAM, $proto)) { 
    print "socket ok\n";
}
else {
    die $!;
}

# Give the socket an address.

if (bind(S, $this)) {
    print "bind ok\n";
}
else {
    die $!;
}

# Call up the server.

if (connect(S,$that)) {
    print "connect ok\n";
}
else {
    die $!;
}

# Set socket to be command buffered.

select(S); $| = 1; select(STDOUT);

# Avoid deadlock by forking.

if($child = fork) {
	$soifstart = '@SQuery{Version{10}:	STARTS 1.0FilterExpression';
	$soifnext = 'RankingExpression';
	$soifend =  'StopWords{1}:	TDefaultAttributeSet{7}:	basic-1DefaultLanguage{5}:	en-USAnswerFields{12}:	title authorSortByFields{20}:	(author a) (title d)MinDocumentScore{3}:	0.5MaxNumberDocuments{2}:	10}';
	print "Filter: ";
	$filter = <STDIN>;
	print "Ranking: ";
	$ranking = <STDIN>;
chop($filter);
chop($ranking);
	$soif = $soifstart . "{" . length($filter) . "}:	" . $filter . $soifnext . "{" . length($ranking) . "}:	" . $ranking . $soifend;
	print S "QUERY\n";
	print "source: ";
	$source=<STDIN>;
	print S $source;
    print S $soif,"\n";
    sleep 10;
}
else {
    while(<S>) {
	print;
    }
}
