/**********************************************************************
 *                              STARTS                                *
 *      Stanford Protocol for Internet Retrieval and Search           *
 *                                                                    *
 *                      Reference Implementation                      *
 *                                                                    *
 *                           Carl Lagoze                              *
 *                      lagoze@cs.cornell.edu                         *
 *                   Department of Computer Science                   *
 *                        Cornell University                          *
 *********************************************************************/

package query;

/**
 * Exception raised when a STARTS query input has unsupported
 * elements.
*/
public class UnsupportedQueryException extends Exception {

    /**
     * Generic constructor for an UnsupportedQueryException
     * @param msg  The information message for the fault.
     */
	public UnsupportedQueryException(String msg) {
		super(msg);
	}
}


