/**********************************************************************
 *                              STARTS                                *
 *      Stanford Protocol for Internet Retrieval and Search           *
 *                                                                    *
 *                      Reference Implementation                      *
 *                                                                    *
 *                           Carl Lagoze                              *
 *                      lagoze@cs.cornell.edu                         *
 *                   Department of Computer Science                   *
 *                        Cornell University                          *
 *********************************************************************/

package soif;

import java.lang.Exception;

/**
 * Exception class for bad SOIF constructs
 */
public class SOIFException extends Exception
{
    /**
     * Build a new SOIFException
     * @param msg  info string for this exception
     */
	public SOIFException(String msg) {
		super(msg);
	}

}

