/**********************************************************************
 *                              STARTS                                *
 *      Stanford Protocol for Internet Retrieval and Search           *
 *                                                                    *
 *                      Reference Implementation                      *
 *                                                                    *
 *                           Carl Lagoze                              *
 *                      lagoze@cs.cornell.edu                         *
 *                   Department of Computer Science                   *
 *                        Cornell University                          *
 *********************************************************************/

package query;

import java.lang.*;

/**
 * Exception class for Source Specific query faults
 */
public class SourceQueryException extends Exception {

    /**
     * Generic constructor for SourceQueryExceptions
     * @param msg  info message for the exception.
     */
    public SourceQueryException(String msg) {
        super(msg);
    }
}
