/**********************************************************************
 *                              STARTS                                *
 *      Stanford Protocol for Internet Retrieval and Search           *
 *                                                                    *
 *                      Reference Implementation                      *
 *                                                                    *
 *                           Carl Lagoze                              *
 *                      lagoze@cs.cornell.edu                         *
 *                   Department of Computer Science                   *
 *                        Cornell University                          *
 *********************************************************************/

package query;

// An abstract class that should be sub-classed for the respective source
// engine.  Methods are used to walk around the abstract parse tree derived
// from the filter string

public abstract class SourceRanking {

    /** TO BE DONE **/
}