/**********************************************************************
 *                              STARTS                                *
 *      Stanford Protocol for Internet Retrieval and Search           *
 *                                                                    *
 *                      Reference Implementation                      *
 *                                                                    *
 *                           Carl Lagoze                              *
 *                      lagoze@cs.cornell.edu                         *
 *                   Department of Computer Science                   *
 *                        Cornell University                          *
 *********************************************************************/

package resource;

import java.lang.*;

/**
 * Exception class when source specific faults happen
 */
public class SourceException extends Exception {

    /**
     * Generic constructor for a SourceException
     * @param msg  info. message for the exception.
     */
    public SourceException(String msg) {
        super(msg);
    }
}
